#include "global.h"

static Token longjmp_stack_t;
static Token longjmp_ctx_top;
static Token longjmp_ctx;

void init_except ()
{
	longjmp_stack_t = new_symbol ("longjmp_StaCk");
	longjmp_ctx_top = new_symbol ("longjmp_StaCkTop");
	longjmp_ctx = new_symbol ("longjmp_CoNtExT");
}

void decl_except_data ()
{
	outprintf (GLOBAL,
	RESERVED_typedef, RESERVED_struct, RESERVED_ucontext, RESERVED_ucontext_t, ';', -1);
	outprintf (FPROTOS,
	RESERVED_int, RESERVED_getcontext, '(', RESERVED_ucontext_t, '*', ')', ';',
	RESERVED_int, RESERVED_setcontext, '(', RESERVED_const, RESERVED_ucontext_t, '*', ')', ';',
	 -1);
	outprintf (STRUCTS,
	RESERVED_struct, longjmp_stack_t, '{',
	RESERVED_char, RESERVED_x, '[', new_symbol (SIZEOF_UCONTEXT), ']', ';',
	RESERVED_struct, longjmp_stack_t, '*', RESERVED_y, ';',
	RESERVED_int, RESERVED_X, ';',
	'}', ';', -1);
	outprintf (GVARS, MainModule ? BLANKT : RESERVED_extern,
	   Reentrant ? RESERVED___thread : BLANKT,
	   RESERVED_struct, longjmp_stack_t, '*', longjmp_ctx_top, ';', -1);
}

NormPtr throw_statement (OUTSTREAM o, NormPtr p)
{
	outprintf (o, '{', longjmp_ctx_top, POINTSAT, RESERVED_X, '=', -1);

	if (CODE [p] == ';')
		outprintf (o, RESERVED_1, ';', -1);
	else { 
		exprret E;
		p = parse_expression_retconv (p, &E, typeID_int, NORMAL_EXPR);
		if (!E.ok) return p + 1;
		outprintf (o, ISTR (E.newExpr), ';', -1);

		free (E.newExpr);
		if (CODE [p] != ';')
			parse_error (p, "excepted ';' after throw expression");
	}

	outprintf (o, RESERVED_setcontext, '(', '(', RESERVED_ucontext_t, '*',
		   ')', longjmp_ctx_top, POINTSAT, RESERVED_x, ')', ';', '}', -1);

	return p + 1;
}

NormPtr try_statement (OUTSTREAM o, NormPtr p)
{
	Token x = RESERVED_x;
	Token y = RESERVED_y;
	Token X = RESERVED_X;
	Token retcode;
	bool have_retcode;

	if (have_retcode = CODE [p] == '(') {
		open_local_scope ();
		if (!issymbol (retcode = CODE [++p]))
			parse_error (p, "try ( 'identifier' )");
		if (CODE [++p] != ')')
			parse_error (p, "try (identifier ')'");
		++p;
		enter_local_obj (retcode, typeID_int);
	} else retcode = internal_identifier1 ();

	outprintf (o, '{', RESERVED_struct, longjmp_stack_t, longjmp_ctx, ';',
		   longjmp_ctx, '.', y, '=', longjmp_ctx_top, ';', longjmp_ctx_top,
		   '=', '&', longjmp_ctx, ';', longjmp_ctx, '.', X, '=', RESERVED_0, ';',
		   RESERVED_getcontext, '(', '(', RESERVED_ucontext_t, '*', ')', longjmp_ctx,
		   '.', x, ')', ';', RESERVED_int, retcode, '=', longjmp_ctx, '.', X, ';',
		   RESERVED_if, '(', '!', retcode, ')', '{', -1);

	p = statement (o, p);
	outprintf (o, longjmp_ctx_top, '=', longjmp_ctx, '.', y, ';', '}', -1);

	if (CODE [p] == RESERVED_else) {
		outprintf (o, RESERVED_else, '{', 
			   longjmp_ctx_top, '=', longjmp_ctx, '.', y, ';', -1);

		p = statement (o, p + 1);

		outprintf (o, '}', -1);
	}

	outprintf (o, '}', -1);
	if (have_retcode) close_local_scope ();

	return p;
}
